﻿@model List<PersonalCare>
@{
    var clientPersonalCare = Model.FirstOrDefault(m => m.ClientType == ClientTypeEnum.Client);
    var spousePersonalCare = Model.FirstOrDefault(m => m.ClientType == ClientTypeEnum.Spouse);
    int i = 0; int j = 0;
}
<h4 class="text-dark font-weight-bold mt-2 mb-5 mr-5">Let's review your Personal Care plans</h4>
<form asp-action="savePersonalCare" class="form fv-plugins-bootstrap fv-plugins-framework" id="PersonalCare_form" method="post" data-ajax="true" data-ajax-begin="onFormBegin" data-ajax-complete="onFormCompleteWithWizard">
    <button id="btn-save-exit-hidden" class="d-none"></button>
    <div class="wizard-content-height">
        @foreach (var item in Model)
        {
            <div id="PersonalCare-@((int)Model[i].ClientType)">
                <h6 class="display-title">@Model[i].Name</h6>
                <div class="row">
                    <input type="hidden" asp-for="@Model[i].Guid" />
                    <input type="hidden" asp-for="@Model[i].Id" />
                    <input type="hidden" asp-for="@Model[i].ClientType" />
                    <div class="col-xl-10">
                        <div class="form-group">
                            <label class="col-form-label font-weight-bold">Please select the appropriate exemption option below:</label>
                            <div class="radio-list" data-type="@((int)Model[i].ClientType)">
                                @foreach (var item1 in Html.GetEnumSelectList<PersonalCareEnum>())
                                {
                                    <div class="d-flex">
                                        <div class="mr-2">
                                            <label class="radio radio-outline radio-outline-2x">
                                                <input asp-for="@Model[i].PersonalCareType" id="PersonalCareType_@j" type="radio"
                                               checked="@((item.ClientType == ClientTypeEnum.Client && item1.Value == ((int)clientPersonalCare.PersonalCareType).ToString()) || (item.ClientType == ClientTypeEnum.Client && clientPersonalCare.Guid==Guid.Empty && item1.Value == ((int)PersonalCareEnum.Facility).ToString()) ||
                                                          (item.ClientType == ClientTypeEnum.Spouse && item1.Value == ((int)spousePersonalCare.PersonalCareType).ToString() || (item.ClientType == ClientTypeEnum.Spouse && spousePersonalCare.Guid==Guid.Empty && item1.Value == ((int)PersonalCareEnum.Facility).ToString()))
                                        ? "checked" : null)"
                                               value="@item1.Value" class="PersonalCareType">
                                                <span></span>
                                            </label>
                                        </div>
                                        <label asp-for="@Model[i].PersonalCareType" for="PersonalCareType_@j">
                                            @item1.Text
                                        </label>
                                    </div>
                                    j++;
                                }
                            </div>
                        </div>
                    </div>
                </div>
                <div class="caregiver" data-type="@((int)Model[i].ClientType)">
                    <div class="form-group d-flex mb-2">
                        <label class="col-form-label w-100px">Caregiver:</label>
                        <div class="w-200px mt-2">
                            <select class="form-control form-control-sm required caregiverId" asp-for="@Model[i].CareGiverId" id="CaregiverId">
                                @foreach (var item2 in @Model[i].ClientType == ClientTypeEnum.Client ? ViewBag.clientCareGivers : ViewBag.spouseCareGivers)
                                {
                                    <option value="@item2.Value" data-subtext="@item2.Group?.Name" selected="@item2.Selected" disabled="@item2.Disabled">@item2.Text</option>
                                }
                            </select>
                        </div>
                    </div>
                </div>
                <div class="caregivername">
                    <div class="form-group d-flex mb-2 mt-2">
                        <label class="col-form-label w-100px">Name:</label>
                        <div class="w-200px mt-2">
                            <input id="CaregiverName" asp-for="@Model[i].CaregiverName" class="form-control form-control-sm capitalize required">
                        </div>
                    </div>
                </div>
                <div class="relationship">
                    <div class="form-group d-flex mb-2">
                        <label class="col-form-label w-100px">Relationship:</label>
                        <div class="w-200px mt-2">
                            <select id="Relationship" class="form-control form-control-sm required" asp-for="@Model[i].Relationship" asp-items="EnumHelper.GetEnumSelectList<PersonalCareRelationShipEnum>()">
                            </select>
                        </div>
                    </div>
                </div>
                @if (item.ClientType == ClientTypeEnum.Client)
                {
                    <hr />
                }
            </div>
            i++;
        }
    </div>
    <partial name="_WizardFooter" />
</form>
<script type="text/javascript">
    $("#PersonalCare_form").validate({
        errorPlacement: function() { },
        errorClass: "input-validation-error",
        invalidHandler: function() {
            _showFormMessage("PersonalCare_form", "danger", "Provide information in all required fields.", "fas fa-exclamation-triangle");
        }
    });
    var showHidePersonalCare = function(clientType) {
        var el = $(`#PersonalCare-${clientType}`);
        el.find(".caregiver").addClass("d-none");
        el.find(".caregivername").addClass("d-none");
        el.find(".relationship").addClass("d-none");
        var type = el.find(".PersonalCareType:checked").val();
        if (type == PersonalCareType.PrimaryCare || type == PersonalCareType.ProviceCare)
            el.find(".caregiver").removeClass("d-none");
    }
    var showHideCareGiver = function(clientType) {
        var el = $(`#PersonalCare-${clientType}`);
        el.find(".caregivername").addClass("d-none");
        el.find(".relationship").addClass("d-none");
        var caregiverId = el.find("select.caregiverId").val();
        var type = el.find(".PersonalCareType:checked").val();
        if (caregiverId == -1 && type != PersonalCareType.Facility) {
            el.find(".caregivername").removeClass("d-none");
            el.find(".relationship").removeClass("d-none");
        }
    }
    setTimeout(function() {
        if ('@clientPersonalCare.CareGiverId' == -1)
            $("#PersonalCare-1 select.caregiverId").val(-1);
        if ('@spousePersonalCare?.CareGiverId' == -1)
            $("#PersonalCare-2 select.caregiverId").val(-1);
        $("select.form-control").selectpicker("refresh");
        showHidePersonalCare(ClientType.CLIENT);
        showHidePersonalCare(ClientType.SPOUSE);
        showHideCareGiver(ClientType.CLIENT);
        showHideCareGiver(ClientType.SPOUSE);
    }, 0);

    $(".PersonalCareType").change(function() {
        var clientType = $(this).closest(".radio-list").attr("data-type");
        var el = $(`#PersonalCare-${clientType}`);
        el.find("#CaregiverId").val(null);
        $("select.form-control").selectpicker("refresh");
        showHidePersonalCare(clientType);
    })

    $(".caregiverId").change(function() {
        var clientType = $(this).closest(".caregiver").attr("data-type");
        var el = $(`#PersonalCare-${clientType}`);
        el.find("#Relationship").val(null);
        $("select.form-control").selectpicker("refresh");
        el.find("#CaregiverName").val("");
        showHideCareGiver(clientType);
    })
</script>